/*
* Local variables
* */
var card0_id;
var card1_id;
var card2_id;
/*
* Request Pagespeed data and draw chart.
* */
function fetchdata(){
  removeElement("fetchdata_btn");
  document.getElementById("overlay").style.display = "block";
  document.getElementById("loader").style.visibility = "visible";
  axios.get('/pagespeed/json')
    .then(function (response) {
      document.getElementById("card0").firstElementChild.id =response.data[0].mobile;
      document.getElementById("card1").firstElementChild.id =response.data[0].avg;
      document.getElementById("card2").firstElementChild.id =response.data[0].desktop;
      document.getElementById("overlay").style.display = "none";
      document.getElementById("loader").style.visibility = "hidden";
      initChart();
    })
    .catch(function (error) {
      var html =  '<div class="alert alert-danger" role="alert">Something went wrong during communicating with the API. Try to refresh the page or try again later... </div>';
      addElement("error_msg","div",html);
      document.getElementById("overlay").style.display = "none";
      document.getElementById("loader").style.visibility = "hidden";
    });
}
/*
* Draw defined charts.
* */
function initChart(){
  card0_id = document.getElementById("card0").firstElementChild.id;
  card1_id = document.getElementById("card1").firstElementChild.id;
  card2_id = document.getElementById("card2").firstElementChild.id;
  drawChart('card0','#2BBCD7',card0_id);
  drawChart('card1','#15CA7B',card1_id);
  drawChart('card2','#D39C49',card2_id);
}
/*
* Define difeerent types of charts (element/color).
* */
function drawChart(card_name, color,card_id) {
  var bar = new ProgressBar.Circle(document.getElementById(card_name), {
    color: color,
    strokeWidth: 4,
    trailWidth: 1,
    easing: 'easeInOut',
    duration: 1400,
    text: {
      autoStyleContainer: false
    },
    from: { color: color, width: 1 },
    to: { color: color, width: 4 },

    step: function(state, circle) {
      circle.path.setAttribute('stroke', state.color);
      circle.path.setAttribute('stroke-width', state.width);

      var value = Math.round(circle.value() * 100);
      if (value === 0) {
        circle.setText('');
      } else {
        circle.setText(value);
      }
    }
  });
  bar.text.style.fontFamily = '"Raleway", Helvetica, sans-serif';
  bar.text.style.top = '46%';
  bar.text.style.fontSize = '2rem';
  bar.animate(card_id);
}
/*
* Remove HTML-TAG
* */
function removeElement(elementId) {
  var element = document.getElementById(elementId);
  element.parentNode.removeChild(element);
}
/*
* Add HTML-TAG
* */
function addElement(parentId, elementTag, html) {
  // Adds an element to the document
  var p = document.getElementById(parentId);
  var newElement = document.createElement(elementTag);
  newElement.innerHTML = html;
  p.appendChild(newElement);
}
